/********************************************************************/
/*                                                                  */
/*  NAME : SC61860 ASSEMBLER HEADDER CODE                           */
/*  FILE : SC61860.h                                                */
/*                                                                  */
/*  REVISION HISTORY:                                               */
/*  Rev : 0.01 2006.11.07  ŏ̃o[W                         */
/*  Rev : 0.02 2021.08.24  DL^,CASE1Ήǉ                 */
/*                         unsigned long -> unsigned int ɕύX     */
/*                                                                  */
/********************************************************************/

/*------------------------------------------------------------------*/
/*  萔`                                                        */
/*------------------------------------------------------------------*/
#define		IM6bit		64			/* Urbgől             */
#define		IM8bit		256			/* Wrbgől             */
#define		IM13bit		8192		/* PRrbgől           */
#define		IM16bit		65536		/* PUrbgől           */
#define		MAXNAME		16			/* xő咷                 */
#define		MAXLEN		256			/* Iyhő咷             */
#define		MAXOPR		128			/* Iyh               */
#define		MAXOBJ		65536		/* őt@CTCY           */
#define		MAXLINE		256			/* PsőoCg             */
#define		MAXINC		256			/* őCN[hlXg     */
#define		MAXOPT		8			/* R}hCIvV   */

#define		LBLOK		0x000d		/* ʃx AhXς  */
#define		LBLNG		0x000e		/* ʃx AhX    */

/*------------------------------------------------------------------*/
/*  ߎʒ`iIy[Vʔʗpj                        */
/*------------------------------------------------------------------*/
enum{
	OP_UNKNOWN = 0x0,	/* s(DB߂ɕϊ)              */
	OP_NUL			,	/* Iyhi1oCg߁j   */
	OP_8			,	/* 8rbgIyh(2oCg)  */
	OP_16			,	/* 16rbgIyh(3oCg) */
	OP_JRP			,	/* ΃Wv+i2oCg߁j*/
	OP_JRM			,	/* ΃Wv-i2oCg߁j*/
	OP_LP			,	/* LP߁i1oCg߁j           */
	OP_CAL			,	/* CAL߁i2oCg߁j          */
	OP_CASE1		,	/* CASE1߁i4oCg߁j        */
	OP_CASE2		,	/* CASE2߁i1oCg߁j        */
	CASE2_OP			/* CASE2Iyhi3xKoCgj    */
};

/*------------------------------------------------------------------*/
/*  \͌ʏo̓e[u\̒`iOutTblj                    */
/*------------------------------------------------------------------*/
typedef struct outtbl {
	unsigned short idx;				/* codetblCfbNX          */
	unsigned short adr;				/* ߊi[AhX             */
	unsigned short byte;			/* ߃oCg(0:Rĝ) */
	unsigned char  code[256]; 		/* ߃R[h                   */
	unsigned short op;				/* Iyho^             */
	unsigned short opdata[2];		/* Iyhԍ(ڼ޽/l)   */
	unsigned char	*bcode;			/* #INCBINpR[h|C^      */
	char	*label; 				/* 擪x(NULL:o^Ȃ)    */
	char	*opr[MAXOPR];			/* Iyh(NULL:o^Ȃ)    */
	char	*comment;				/* Rg(NULL:o^Ȃ)      */
	char	line[MAXLINE*2];		/* ̓obt@(512oCg)      */
} OUTTBL;

/*------------------------------------------------------------------*/
/*  xe[u\̒`ilbltblj                              */
/*------------------------------------------------------------------*/
typedef struct lbl {
	void * np;						/* x\̃|C^       */
	unsigned short adr;				/* ΉAhX                 */
	char	name[1];				/* x(1Byteȏ)        */
} LBL;

/*------------------------------------------------------------------*/
/*  ef[^ϊe[u\̒`                                */
/*------------------------------------------------------------------*/
/* Iyhϊe[u\ */
typedef struct opr {
	unsigned short code;			/* IyhR[hԍ         */
	char	name[9];				/* Iyh               */
} OPR;
/* ^ߎ */
enum {
	OP_EQU		=	0	,	/* EQU      */
	OP_ORG				,	/* ORG      */
	OP_START			,	/* START    */
	OP_DS				,	/* DS       */
	OP_DB				,	/* DB       */
	OP_DW				,	/* DW       */
	OP_DL				,	/* DL       */
	OP_INCLUDE			,	/* #INCLUDE */
	OP_INCBIN			,	/* #INCBIN  */
	OP_LIST				,	/* #LIST    */
	OP_NOLIST			,	/* #NOLIST  */
	OP_EJECT				/* #EJECT   */
};
/* ^ߕϊe[u */
#define		MAXDIR		12
struct opr Directivetbl[MAXDIR] = {
{	OP_EQU		,	"EQU"		},
{	OP_ORG		,	"ORG"		},
{	OP_START	,	"START"		},
{	OP_DS		,	"DS"		},
{	OP_DB		,	"DB"		},
{	OP_DW		,	"DW"		},
{	OP_DL		,	"DL"		},
{	OP_INCLUDE	,	"INCLUDE"	},
{	OP_INCBIN	,	"INCBIN"	},
{	OP_LIST		,	"LIST"		},
{	OP_NOLIST	,	"NOLIST"	},
{	OP_EJECT	,	"EJECT"		}
};

/* if`else`endif}Nϊe[u */
#define		IFLEVEL		255	/* iflXgx */
enum {
	OP_IF		=	0	,	/* if    */
	OP_ELSE				,	/* else  */
	OP_ENDIF				/* endif */
};
#define		MACDIR		3
struct opr MacTbl[MACDIR] = {
{	OP_IF		,	"IF"		},
{	OP_ELSE		,	"ELSE"		},
{	OP_ENDIF	,	"ENDIF"		}
};

#define	MAXMN		6				/* jjbNő咷(6) */

/* ߕϊe[u\ */
typedef struct fnc {
	unsigned char	code;			/* ߃R[hԍ               */
	unsigned char	byte;			/* ߃oCg                 */
	unsigned char	kind;			/* ߌ(i[)   */
	char			name[MAXMN];	/* jjbN               */
} FNC;
#define		MAXOP	137
struct fnc codetbl[MAXOP] = {
/*	opcode,	byte,	kind,jjbN	*/
{	0x00,	2,	 OP_8	,"LII"		},
{	0x01,	2,	 OP_8	,"LIJ"		},
{	0x02,	2,	 OP_8	,"LIA"		},
{	0x03,	2,	 OP_8	,"LIB"		},
{	0x04,	1,	 OP_NUL	,"IX"		},
{	0x05,	1,	 OP_NUL	,"DX"		},
{	0x06,	1,	 OP_NUL	,"IY"		},
{	0x07,	1,	 OP_NUL	,"DY"		},
{	0x08,	1,	 OP_NUL	,"MVW"		},
{	0x09,	1,	 OP_NUL	,"EXW"		},
{	0x0a,	1,	 OP_NUL	,"MVB"		},
{	0x0b,	1,	 OP_NUL	,"EXB"		},
{	0x0c,	1,	 OP_NUL	,"ADN"		},
{	0x0d,	1,	 OP_NUL	,"SBN"		},
{	0x0e,	1,	 OP_NUL	,"ADW"		},
{	0x0f,	1,	 OP_NUL	,"SBW"		},
{	0x10,	3,	 OP_16	,"LIDP"		},
{	0x11,	2,	 OP_8	,"LIDL"		},
{	0x12,	2,	 OP_8	,"LIP"		},
{	0x13,	2,	 OP_8	,"LIQ"		},
{	0x14,	1,	 OP_NUL	,"ADB"		},
{	0x15,	1,	 OP_NUL	,"SBB"		},
{	0x18,	1,	 OP_NUL	,"MVWD"		},
{	0x19,	1,	 OP_NUL	,"EXWD"		},
{	0x1a,	1,	 OP_NUL	,"MVBD"		},
{	0x1b,	1,	 OP_NUL	,"EXBD"		},
{	0x1c,	1,	 OP_NUL	,"SRW"		},
{	0x1d,	1,	 OP_NUL	,"SLW"		},
{	0x1e,	1,	 OP_NUL	,"FILM"		},
{	0x1f,	1,	 OP_NUL	,"FILD"		},
{	0x20,	1,	 OP_NUL	,"LDP"		},
{	0x21,	1,	 OP_NUL	,"LDQ"		},
{	0x22,	1,	 OP_NUL	,"LDR"		},
{	0x23,	1,	 OP_NUL	,"CLRA"		},
{	0x24,	1,	 OP_NUL	,"IXL"		},
{	0x25,	1,	 OP_NUL	,"DXL"		},
{	0x26,	1,	 OP_NUL	,"IYS"		},
{	0x27,	1,	 OP_NUL	,"DYS"		},
{	0x28,	2,	 OP_JRP	,"JRNZP"	},
{	0x29,	2,	 OP_JRM	,"JRNZM"	},
{	0x2a,	2,	 OP_JRP	,"JRNCP"	},
{	0x2b,	2,	 OP_JRM	,"JRNCM"	},
{	0x2c,	2,	 OP_JRP	,"JRP"		},
{	0x2d,	2,	 OP_JRM	,"JRM"		},
{	0x2f,	2,	 OP_JRM	,"LOOP"		},
{	0x30,	1,	 OP_NUL	,"STP"		},
{	0x31,	1,	 OP_NUL	,"STQ"		},
{	0x32,	1,	 OP_NUL	,"STR"		},
{	0x34,	1,	 OP_NUL	,"PUSH"		},
{	0x35,	1,	 OP_NUL	,"RST"		},
{	0x35,	1,	 OP_NUL	,"DATA"		},
{	0x37,	1,	 OP_NUL	,"RTN"		},
{	0x38,	2,	 OP_JRP	,"JRZP"		},
{	0x39,	2,	 OP_JRM	,"JRZM"		},
{	0x3a,	2,	 OP_JRP	,"JRCP"		},
{	0x3b,	2,	 OP_JRM	,"JRCM"		},
{	0x40,	1,	 OP_NUL	,"INCI"		},
{	0x41,	1,	 OP_NUL	,"DECI"		},
{	0x42,	1,	 OP_NUL	,"INCA"		},
{	0x43,	1,	 OP_NUL	,"DECA"		},
{	0x44,	1,	 OP_NUL	,"ADM"		},
{	0x45,	1,	 OP_NUL	,"SBM"		},
{	0x46,	1,	 OP_NUL	,"ANMA"		},
{	0x47,	1,	 OP_NUL	,"ORMA"		},
{	0x48,	1,	 OP_NUL	,"INCK"		},
{	0x49,	1,	 OP_NUL	,"DECK"		},
{	0x4a,	1,	 OP_NUL	,"INCM"		},
{	0x4b,	1,	 OP_NUL	,"DECM"		},
{	0x4c,	1,	 OP_NUL	,"INA"		},
{	0x4d,	1,	 OP_NUL	,"NOPW"		},
{	0x4e,	2,	 OP_8	,"WAIT"		},
{	0x4f,	1,	 OP_NUL	,"CUP"		},
{	0x50,	1,	 OP_NUL	,"INCP"		},
{	0x51,	1,	 OP_NUL	,"DECP"		},
{	0x52,	1,	 OP_NUL	,"STD"		},
{	0x53,	1,	 OP_NUL	,"MVDM"		},
{	0x54,	1,	 OP_NUL	,"READM"	},
{	0x55,	1,	 OP_NUL	,"MVMD"		},
{	0x56,	1,	 OP_NUL	,"READ"		},
{	0x57,	1,	 OP_NUL	,"LDD"		},
{	0x58,	1,	 OP_NUL	,"SWP"		},
{	0x59,	1,	 OP_NUL	,"LDM"		},
{	0x5a,	1,	 OP_NUL	,"SL"		},
{	0x5b,	1,	 OP_NUL	,"POP"		},
{	0x5d,	1,	 OP_NUL	,"OUTA"		},
{	0x5f,	1,	 OP_NUL	,"OUTF"		},
{	0x60,	2,	 OP_8	,"ANIM"		},
{	0x61,	2,	 OP_8	,"ORIM"		},
{	0x62,	2,	 OP_8	,"TSIM"		},
{	0x63,	2,	 OP_8	,"CPIM"		},
{	0x64,	2,	 OP_8	,"ANIA"		},
{	0x65,	2,	 OP_8	,"ORIA"		},
{	0x66,	2,	 OP_8	,"TSIA"		},
{	0x67,	2,	 OP_8	,"CPIA"		},
{	0x69,	1,	 OP_CASE2,"CASE2"	},
{	0x69,	1,	 OP_CASE2,"CASE"	},
{	0x6b,	2,	 OP_8	,"TEST"		},
{	0x6f,	1,	 OP_NUL	,"CDN"		},
{	0x70,	2,	 OP_8	,"ADIM"		},
{	0x71,	2,	 OP_8	,"SBIM"		},
{	0x74,	2,	 OP_8	,"ADIA"		},
{	0x75,	2,	 OP_8	,"SBIA"		},
{	0x78,	3,	 OP_16	,"CALL"		},
{	0x79,	3,	 OP_16	,"JP"		},
{	0x7a,	4,	 OP_CASE1,"CASE1"	},
{	0x7a,	4,	 OP_CASE1,"SET"		},
{	0x7c,	3,	 OP_16	,"JPNZ"		},
{	0x7d,	3,	 OP_16	,"JPNC"		},
{	0x7e,	3,	 OP_16	,"JPZ"		},
{	0x7f,	3,	 OP_16	,"JPC"		},
{	0x80,	1,	 OP_LP	,"LP"		},
{	0xc0,	1,	 OP_NUL	,"INCJ"		},
{	0xc1,	1,	 OP_NUL	,"DECJ"		},
{	0xc2,	1,	 OP_NUL	,"INCB"		},
{	0xc3,	1,	 OP_NUL	,"DECB"		},
{	0xc4,	1,	 OP_NUL	,"ADCM"		},
{	0xc5,	1,	 OP_NUL	,"SBCM"		},
{	0xc6,	1,	 OP_NUL	,"TSMA"		},
{	0xc7,	1,	 OP_NUL	,"CPMA"		},
{	0xc8,	1,	 OP_NUL	,"INCL"		},
{	0xc9,	1,	 OP_NUL	,"DECL"		},
{	0xca,	1,	 OP_NUL	,"INCN"		},
{	0xcb,	1,	 OP_NUL	,"DECN"		},
{	0xcc,	1,	 OP_NUL	,"INB"		},
{	0xce,	1,	 OP_NUL	,"NOPT"		},
{	0xd0,	1,	 OP_NUL	,"SC"		},
{	0xd1,	1,	 OP_NUL	,"RC"		},
{	0xd2,	1,	 OP_NUL	,"SR"		},
{	0xd4,	2,	 OP_8	,"ANID"		},
{	0xd5,	2,	 OP_8	,"ORID"		},
{	0xd6,	2,	 OP_8	,"TSID"		},
{	0xd8,	1,	 OP_NUL	,"LEAVE"	},
{	0xda,	1,	 OP_NUL	,"EXAB"		},
{	0xdb,	1,	 OP_NUL	,"EXAM"		},
{	0xdd,	1,	 OP_NUL	,"OUTB"		},
{	0xdf,	1,	 OP_NUL	,"OUTC"		},
{	0xe0, 	2,	 OP_CAL	,"CAL"		}
};

/*------------------------------------------------------------------*/
/*  G[ʒ`                                                  */
/*------------------------------------------------------------------*/
enum {
	NORM		=	0	,	/* I                     */
	INZERR				,	/* ُ                   */
	EOFERR				,	/* t@CI                 */
	LOFLOW				,	/* Ps̕I[o[   */
	OPOFLOW				,	/* IyhI[o[ */
	LBOFLOW				,	/* Ps̕I[o[   */
	NOORG				,	/* ORGߒ`Ȃ            */
	NOENT				,	/* IyhLqȂ           */
	EQUNOLBL			,	/* EQUɃxGgȂ      */
	ILLOPR				,	/* IyhLq~X           */
	ILLSTART			,	/* STARTQȏ゠        */
	ILLCANMA			,	/* J}Lq         */
	ILLDQUO				,	/* ٺð/ ُ       */
	DUPLBL				,	/* xLqQȏ゠     */
	ILLLBL				,	/* xɗpłȂ     */
	LBLNOENT			,	/* xo^Ȃ               */
	LBNOALOC			,	/* xo^Ȃ               */
	UNDEFOPR			,	/* Y߂Ȃ/Lq@̃~X  */
	OFLOW				,	/* Iyhl͈͊O         */
	JOFLOW				,	/* ΃Wv͈͊O         */
	AOFLOW				,	/* o̓obt@I[o[         */
	ADOFLOW				,	/* AZuAhXI[o[   */
	EOFLOW				,	/* sAhXORG菬  */
	CALERR				,	/* vZُ( 0 Z )   */
	IFNEST				,	/* #if`#else`#endiflXgُ */
	INCNOFILE			,	/* #includet@CȂ       */
	INCERR				,	/* #includelXgُ           */
	REGERR				,	/* CWX^ԍُ       */
	ILLBIN				,	/* oCiǂݍُ݈         */
	ILLBMP					/* rbg}bvǂݍُ݈     */
};
/*------------------------------------------------------------------*/
/* G[bZ[Wϊe[u\                                 */
/*------------------------------------------------------------------*/
typedef struct err {
	unsigned short code;			/* R[hԍ                   */
	char	msg[32];				/* G[bZ[W(32ȓ) */
} ERR;

/* G[bZ[Wϊe[u */
#define		MAXERR		28
struct err errtbl[MAXERR] = {
{	LOFLOW	    ,	"Line Length is Too Long"		},
{	OPOFLOW	    ,	"Oprand Length is Too Long"		},
{	LBOFLOW	    ,	"LABEL Length is Too Long"		},
{	NOORG	    ,	"ORG Not Entry"					},
{	NOENT	    ,	"Operand Not Entry"				},
{	EQUNOLBL    ,	"EQU without Label"				},
{	ILLOPR	    ,	"Illegal Operand"				},
{	ILLSTART    ,	"START Already Defined"			},
{	ILLCANMA    ,	"Illegal [,]"					},
{	ILLDQUO	    ,	"Illegal ['']or[(]or[)]"		},
{	DUPLBL	    ,	"LABEL Already Defined"			},
{	ILLLBL	    ,	"LABEL Type Mismatch"			},
{	LBLNOENT    ,	"Undefined LABEL"				},
{	LBNOALOC    ,	"Could Not Defined LABEL"		},
{	UNDEFOPR    ,	"Operation Type Mismatch"		},
{	OFLOW	    ,	"Operand Range Over"			},
{	JOFLOW	    ,	"Jump Address Over"				},
{	AOFLOW	    ,	"Output Buffer Over Flow"		},
{	ADOFLOW	    ,	"Assemble Address Over Flow"	},
{	EOFLOW	    ,	"Execute Address Illegal"		},
{	CALERR	    ,	"Could Not Calculate"			},
{	IFNEST	    ,	"Illegal [if] - [endif]"		},
{	INCNOFILE   ,	"Invalid Include File Name"		},
{	INCERR	    ,	"Could Not Nest Include"		},
{	REGERR	    ,	"Illegal Register Number"		},
{	ILLBMP	    ,	"Illegal Bitmap File Format"	},
{	ILLBIN	    ,	"Illegal Binary File Format"	},
{	0		    ,	"Unknown"						}
};

/*------------------------------------------------------------------*/
/* IvV\                                             */
/*------------------------------------------------------------------*/
typedef struct set {
	char	ent[MAXNAME+2];			/* o^x */
	char	let[MAXNAME+2];			/* x */
} SETOPT;

/*------------------------------------------------------------------*/
/* rbg}bvǂݍݗp}N`                                 */
/*------------------------------------------------------------------*/
#define	Getlong(x) (((unsigned int)ImgTbl[x+3])<<24)+(((unsigned int)ImgTbl[x+2])<<16)+(((unsigned int)ImgTbl[x+1])<<8)+((unsigned int)ImgTbl[x]&0xff)
#define	Getword(x) ((((unsigned short)ImgTbl[x+1])<<8)+(unsigned short)ImgTbl[x])
#define	Getparret(x) (((unsigned short)ImgTbl[x+2])+((unsigned short)ImgTbl[x+1])+(unsigned short)ImgTbl[x])
